# $Id: mod_html.py,v 1.1.1.1 2002/04/28 09:16:49 mis Exp $
# Module generates xml docbook document for PLD-Guide

import re
import os
import sys
import string

def mirrortool_summary():
    return "generate HTML document"

def mirrortool_options():
    return "out=FILE - save output to FILE"
    

def out_url(url):
    return """<a href="%s">%s</a><br>""" % (url, url)


def out_mirror(m):
    r = "<li>"

    for url in m.urls:
        r += out_url(url)

    r += """    
 <p>
  %s, %s, %s
 </p>
</li>
""" % (m.organisation, m.city, m.country)
    return r

def mirrortool_out(mirror_index, out = None):
    global fp
    
    try:
        if out:
            fp = open(out, "w")
        else:
            fp = sys.stdout
            
    except IOError, e:
        print "%s: %s" % (e.filename, e.strerror)
        raise

    hdr = """
<html>
<head>
  <title>Download</title>
</head>
<body>  
  <p>
    We provide main servers with our distribution, they are
    widely mirrored around the world.
  </p>
"""
    fp.write(hdr)

    m = mirror_index.get_mirror('main')
    
    mainsites = """
    \n<p>Our main sites (%s, %s, %s) </p>\n<ul>\n""" % (m.organisation,
                                                        m.city, m.country)
    for url in m.urls:
        mainsites += "<li>"
        mainsites += out_url(url)
        mainsites += "</li>"
    mainsites += "</ul>"

    fp.write("%s <p>Mirrors:</p>\n\n" % mainsites)
    
    
    continents = mirror_index.continents()
    for continent in continents:
        fp.write("\n<p>%s</p>\n<ul>\n" % continent)
        countries = mirror_index.countries(continent)
        for country in countries:
            fp.write("\n<p>%s</p>\n<ul>\n" % country)
            for m in mirror_index.mirrors(continent, country):
                if m.name != "main":
                    fp.write(out_mirror(m))
            fp.write("\n</ul>\n")
        fp.write("</ul>\n\n")

    fp.write("\n</body></html>")
    print "Saved %s" % out
