# $Id: mod_xml-pldoc.py,v 1.1.1.1 2002/04/28 09:16:50 mis Exp $
# Module generates xml docbook document for PLD-Guide

import re
import os
import sys
import string

def mirrortool_summary():
    return "generate xml docbook document for PLD-Guide"

def mirrortool_options():
    return "out=FILE - save output to FILE"
    

def out_url(url):
    return """
<para>
  <ulink url="%s">%s</ulink>
</para>""" % (url, url)


def out_mirror(m):
    r = "<listitem>"

    for url in m.urls:
        r += out_url(url)

    r += """    
 <para>
  %s, %s, %s
 </para>
</listitem>
""" % (m.organisation, m.city, m.country)
    return r

def mirrortool_out(mirror_index, out = None):
    global fp
    
    try:
        if out:
            fp = open(out, "w")
        else:
            fp = sys.stdout
            
    except IOError, e:
        print "%s: %s" % (e.filename, e.strerror)
        raise

    hdr = """
<section id="download">
  <title>Download</title>
  <para>
    We provide main servers with our distribution, they are
    widely mirrored around the world.
  </para>
"""
    fp.write(hdr)

    fp.write("\n<para>Our main sites</para>\n<itemizedlist>\n")
    m = mirror_index.get_mirror('main')
    fp.write(out_mirror(m))
    fp.write("</itemizedlist>\n\n")
    fp.write("<para>Mirrors</para>\n\n")
    
    
    continents = mirror_index.continents()
    for continent in continents:
        fp.write("\n<para>%s</para>\n<itemizedlist>\n" % continent)
        countries = mirror_index.countries(continent)
        for country in countries:
            fp.write("\n<para>%s</para>\n<itemizedlist>\n" % country)
            for m in mirror_index.mirrors(continent, country):
                if m.name != "main":
                    fp.write(out_mirror(m))
            fp.write("\n</itemizedlist>\n")
        fp.write("</itemizedlist>\n\n")

    fp.write("\n</section>")
    print "Saved %s" % out
